import sys
import random
import datetime
import math
from datetime import timedelta

from ardi.driver import histdriverbase

def fixdate(dt):
	ps = dt.find('.')
	if ps > -1:
		return dt[0:ps]
	return dt

class ardisimdriver:
    def __init__(self):
        self.path = ""
        self.samples=0
        self.per=75
	
    def SetAddress(self, addr):
        self.path = addr
		
    def Connect(self):
		try:		
			#self.con = sql.connect(self.path)
			return True
		except:
			return False		
		
    def Disconnect(self):
		#self.con.close()
		pass
        
    def Query(self, points, start,end,function,grain,first):

		changepersec = 0.002;
		self.core.logger.info("Query Started: '" + function + "' between " + start + " and " + end + " - " + str(grain) + " samples") 								

		sd = datetime.datetime.strptime( start, "%Y-%m-%d %H:%M:%S" )
		ed = datetime.datetime.strptime( end, "%Y-%m-%d %H:%M:%S" )

		sdbase = ((sd - datetime.datetime(1970,1,1)).total_seconds() * changepersec) % 90

		samplebase = sdbase

		if sd == ed:
			out = ""
			n = 0
			#print "Oututting Points For " + str(sd)
			for p in points:
				#val = round(random.random() * 100.0,2)
				val = (round(math.sin(samplebase + (n * 0.01)),3) * 50) + 50
				out = out + self.core.AddRecord(n,sd,val,p)
				n= n + 1
			#sd = sd + step
			return out.encode('ascii')

		diff = ed - sd

		secs = diff.total_seconds()

		count = 50
		
		if int(grain) > 0:
			count = secs / int(grain)
		else:
			count = -int(grain)
			if count <= 1:	
				count = 2;

		if int(grain) < 0:
			count = -int(grain)

		stepsize = secs / count
		step = timedelta(seconds=stepsize)

		out = ""

		if (function == 'avg') or (function == 'min') or (function == 'max'):
			#self.core.logger.info("Statistical Function: " + function)
			count = secs / 10

			if count > 100:
				count = 100;

			stepsize = secs / count
			step = timedelta(seconds=stepsize)
			n=0
			for p in points:
				mn = -99999
				mx = 99999
				ttl = 0
				for x in range(0,int(count)):
					val = (round(math.sin(samplebase + (n * 0.01)),3) * 50) + 50
					if (val < mn):
						mn = val
					if (val > mx):
						mx = val
					ttl = ttl + val
					samplebase = samplebase + (changepersec * stepsize)

				if (function == 'avg'):
					val = ttl / count
				if (function == 'min'):
					val = mn
				if (function == 'max'):
					val = mx
					
				out = out + self.core.AddRecord(n,sd,val,p)
				n= n + 1

			self.core.logger.info("Query Complete")
			return out.encode('ascii')

		for x in range(0,int(count)):
			n = 0
			for p in points:
				val = (round(math.sin(samplebase + (n * 0.01)),3) * 50) + 50
				out = out + self.core.AddRecord(n,sd,val,p)
				n= n + 1
			sd = sd + step
			
			samplebase = samplebase + (changepersec * stepsize)

		return out.encode('ascii')
		            
class driverfactory:
    def createinstance(self):
        return ardisimdriver()
            
if __name__ == "__main__":
    sdf = driverfactory()
    base = histdriverbase.historian()
    base.start(sdf)